#include <stdio.h>

static long long int m[2500][2500];
static int s[10000000];
void f(long long int x,long long int y,long long int a,long long int b){
for(long long int i=x;i<b;i++){
    for(long long int j=y;j<a;j++){
        if(m[i][j]!=m[x][y]){
            s[m[x][y]]=2;

        }
        else{
            if(!(i==x && j==y)){
            m[i][j]=0;
            }
        }
    }
}
    if(s[m[x][y]]==0){
        s[m[x][y]]=1;}

m[x][y]=0;
}


int main()
{
    long long int n,k;
    long int sum=0;
    scanf("%lld %lld",&n,&k);
    for(long long int i=0;i<n;i++){
        for(long long int j=0;j<n;j++){
            scanf("%lld",&m[i][j]);
        }
    }
    for(long long int i=0;i<n;i++){
        for(long long int j=0;j<n;j++){
            if((m[i][j]==0 && s[m[i][j]]==1) || s[m[i][j]]==2){

            }
            else if(s[m[i][j]]==1 && m[i][j]!=0){
                s[m[i][j]]=2;
            }

            else{
                long long int a=j,b=i;
                while(m[i][a]==m[i][j] && a<n){a++;}
                while(m[b][j]==m[i][j] && b<n){b++;}
                f(i,j,a,b);
            }
        }
    }
    for(long long int i=1;i<=k;i++){
        if(s[i]==1){
            sum++;
        }
    }
    printf("%ld",sum);
    /*for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            printf("%d ",m[i][j]);
        }
        printf("\n");
    }*/
    return 0;
}